Subject: Re: [ANNOUNCE] Java Git (aka jgit) has switched to 3-clause BSD

From: "Shawn O. Pearce" <[email-masked]>
Date: Mon, 26 May 2008 19:44:45 -0400

Chris Frey <[email-masked]> wrote:
> On Mon, May 26, 2008 at 01:22:25PM +0200, Vegard Nossum wrote:
> > It does concern me, because I enjoy git and free software in general.
> > I am not trolling or trying to stop the change of license in any way,
> > but simply give a heads up to what I believe might potentially be a
> > legal issue. Maybe there are in fact no other authors that have
> > participated, but in that case I think it is a fact worthy of explicit
> > mention.
> 
> I share your concerns about licensing and keeping things accurate when it
> comes to things like changing licenses, so I took a quick look at the
> bsd branch of the jgit git tree, to see if there were any glaring
> omissions.
> 
> I'm not sure that git-blame is the best way to deal with this kind of task,
> but in this case, it worked out well.  From my analysis of git-log output,
> the lines of code from contributors who haven't explicitly consented are
> maybe 10 lines.  Looks like a job well done to me.

Thanks for your comments.  I think we are OK with the change,
as Chris points out.  Here's more details about the complete
list of contributors to jgit, since the beginning of time.

$ git log --pretty=format:%ae \
    bsd jgit org.spearce.jgit org.spearce.jgit.test \
    | sort | uniq -c | sort -nr
 364 [email-masked]
 175 [email-masked]
  21 [email-masked]
   8 [email-masked]
   2 [email-masked]
   1 [email-masked]

Now I asked for consent from the top 3 (me, robin, dwatson).
The 4th one down ([email-masked]) is also Robin.  That
leaves only Roger C. Soares and Thad Hughes as ever having
made a contribution to jgit, surviving line or not, and who
were not consulted specifically about the license change.

The total size of their deltas is:

$ for u in [email-masked] [email-masked]; \
  do \
    echo $u $(git log -p --author=$u bsd \
    jgit org.spearce.jgit org.spearce.jgit.test \
    | grep '^+' | wc -l); \
  done
[email-masked] 9
[email-masked] 5
$ git log -p bsd | grep '^+' | wc -l
  122576

So in all time these users have added a total of 14 lines between
them.  Out of 122,576 total added lines.  It amounts to only 0.011%
of the total contribution.  In the US a change this small may not
even be copyrightable.

Obviously I am only counting + lines in patches.  The - lines
may also have some value in certain contexts.  But then we also
get into the discussion of what is copyrighted.  The patch or the
final result?

In the 3 changes between Roger and Thad the patches were all very
small.  They are minor bug fixes that probably would come out the
same way no matter who wrote them.  E.g. in one Roger deleted an
extra ";" at the end of a line (fixed ";;" to ";").  I'm not sure
anyone else on Earth could have written that change differently.

I hate to trivialize someone's contribution, but the reality is
that in jgit there are only 3 interesting authors at this time.
All were consulted about this license change, and all gave their
consent via a public posting to this mailing list.

-- 
Shawn.